<?php
session_start();
require __DIR__ . '/vendor/autoload.php';

use PhotoPrismUpload\API\PhotoPrism;

?>
<html>
    <head>
    <style>
        .form-wrapper {
            display: grid;
            grid-template-rows: auto auto auto;
            grid-auto-columns: auto auto;
            max-width: 300px;
        }
        label[for="album"] {
            grid-column: 1;
            grid-row: 1;
        }
        #album {
            grid-column: 2;
            grid-row: 1;
        }
        #input {
            grid-row: 2;
            grid-column: 1/3;
        }
        .form-wrapper > form:nth-child(1) {
            display: inherit;
        }
        input[type=submit] {
            grid-column: 1/3;
            grid-row: 3;
            justify-self: center;
        }
    </style>
    </head>
    <body></body>
<?php

$config = require(__DIR__ . '/config.php');
$api = new PhotoPrism($config);
$albums = [];
try {
    $api->login();
} catch (\Exception $e) {
    die('Fehler: ' . $e->getMessage());
}

if (!isset($_POST['submit'])) {
    if (!isset($_GET['token'])) {
        die('Sorry, kein Zugriff');
    }
    $token = $_GET['token'];
    $tokens = explode(',', $token);
    try {
        $albums = $api->getAlbumsByTokens($tokens);
    } catch (\Exception $e) {
        die('Fehler: ' . $e->getMessage());
    }
    if (empty($albums) && (empty($config['noAlbumToken']) || !in_array($config['noAlbumToken'], $tokens))) {
        die('Falscher Token');
    }
    ?>
    <script>
        window.tooLarge = false;
        window.tooManyFiles = false;
        function validateForm() {
            const isInvalid = window.tooLarge || window.tooManyFiles;
            console.log('Validating', window.tooLarge, window.tooManyFiles, isInvalid);
            if (isInvalid) {
                const errorDiv = document.getElementById('error');m
                errorDiv.innerText = '';
                errorDiv.innerText += window.tooLarge ? 'Zu groß, Upload muss weniger als 200MB sein. ' : '';
                errorDiv.innerText += window.tooManyFiles ? 'Zu viele Dateien, maximal 200 erlaubt. ' : '';
                errorDiv.style.display = 'block';
            }
            return !isInvalid;
        }
    </script>
    <div class="form-wrapper">
        <form method="POST" enctype="multipart/form-data" onsubmit="return validateForm();">
            <label for="album">Zu Album hinzufügen</label>
            <select name="album" id="album">
                <option value="">---</option>
                <?php foreach ($albums as $album) {
                    echo '<option value="' . $album->uid . '">' . $album->title . '</option>\n';
                } ?>
            </select>
            <!--<label></label>
            <input type="text" />!-->
            <input multiple type="file" name="files[]" id="input" required/>
            <input type="submit" name="submit" value="Upload" />
        </form>
        <div id="error" style="display:none"></div>
    </div>
    <script>
        const input = document.getElementById('input')

        input.addEventListener('change', (event) => {
            const errorDiv = document.getElementById('error');
            errorDiv.innerText = '';
            errorDiv.style.display = 'none';

            const target = event.target;
            let totalSize = 0;
            if (target.files) {
                for (file of target.files) {
                    totalSize += file.size;
                }
            }
            const sizeInMb = totalSize / 1000 / 1000;
            window.tooLarge = sizeInMb >= 200;
            console.log('Total size:', totalSize, 'too large: ', window.tooLarge);
            window.tooManyFiles = target.files.length > 200;
            console.log('Total files:', target.files.length, 'too many: ', window.tooManyFiles);
        });
    </script>
    <?php
    die();
}
try {
    $api->uploadPhotos($_POST['album']);
} catch (\Exception $e) {
    die('Fehler: ' . $e->getMessage());
}
?>
Erfolg! <a href=".">Zurück</a>